"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.filterArray = void 0;
const validateQueryProperty_1 = require("../utils/validateQueryProperty");
const filterArray = () => (arr, { operators }) => {
    if (arr && !Array.isArray(arr)) {
        throw new Error("Invalid query parameter $and. It has to be an array");
    }
    if (Array.isArray(arr)) {
        return arr.map((current) => (0, validateQueryProperty_1.validateQueryProperty)(current, operators));
    }
    return arr;
};
exports.filterArray = filterArray;
