"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createRelated = void 0;
const feathers_hooks_common_1 = require("feathers-hooks-common");
const getItemsIsArray_1 = require("../utils/getItemsIsArray");
function createRelated({ service, multi = true, data, createItemsInDataArraySeparately = true }) {
    if (!service || !data) {
        throw "initialize hook 'createRelated' completely!";
    }
    return (context) => __awaiter(this, void 0, void 0, function* () {
        // @ts-expect-error wait for feathers-hooks-common to update
        (0, feathers_hooks_common_1.checkContext)(context, "after", undefined, "createRelated");
        const { items } = (0, getItemsIsArray_1.getItemsIsArray)(context);
        let dataToCreate = (yield Promise.all(items.map((item) => __awaiter(this, void 0, void 0, function* () { return data(item, context); })))).filter(x => !!x);
        if (createItemsInDataArraySeparately) {
            dataToCreate = dataToCreate.flat();
        }
        if (!dataToCreate || dataToCreate.length <= 0) {
            return context;
        }
        if (multi) {
            yield context.app.service(service).create(dataToCreate);
        }
        else {
            yield Promise.all(dataToCreate.map((item) => __awaiter(this, void 0, void 0, function* () { return context.app.service(service).create(item); })));
        }
        return context;
    });
}
exports.createRelated = createRelated;
