import { checkMulti } from "./hooks/checkMulti";
import { setData } from "./hooks/setData";
import { runPerItem } from "./hooks/runPerItem";
export declare const hooks: {
    checkMulti: typeof checkMulti;
    setData: typeof setData;
    runPerItem: (actionPerItem: (item: any, context: import("@feathersjs/feathers/lib").HookContext<import("@feathersjs/feathers/lib").Application<any, any>, any>) => any, _options?: import("./types").HookRunPerItemOptions | undefined) => import("./types").ReturnAsyncHook;
};
export { checkMulti };
export { createRelated } from "./hooks/createRelated";
export { setData };
export { removeRelated } from "./hooks/removeRelated";
export { runPerItem };
import { debounceMixin, DebouncedService, DebouncedStore } from "./mixins/debounce-mixin";
export declare const mixins: {
    debounceMixin: typeof debounceMixin;
    DebouncedStore: typeof DebouncedStore;
};
export { debounceMixin };
export { DebouncedService };
export { DebouncedStore };
export { getPaginate } from "./utils/getPaginate";
export { isMulti } from "./utils/isMulti";
export { isPaginated } from "./utils/isPaginated";
export { mergeQuery } from "./utils/mergeQuery/index";
export { mergeArrays } from "./utils/mergeQuery/mergeArrays";
export { pushSet } from "./utils/pushSet";
export { setResultEmpty } from "./utils/setResultEmpty";
export { markHookForSkip } from "./utils/markHookForSkip";
export { filterQuery } from "./utils/filterQuery";
export { getItemsIsArray } from "./utils/getItemsIsArray";
export { onDelete } from "./hooks/onDelete";
export { shouldSkip } from "./utils/shouldSkip";
export { validateQueryProperty } from "./utils/validateQueryProperty";
export { filterArray } from "./filters/array";
export * from "./types";
