"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.filterQuery = void 0;
const adapter_commons_1 = require("@feathersjs/adapter-commons");
function filterQuery(query, _options) {
    var _a, _b;
    query = query || {};
    _options = _options || {};
    const { service } = _options, options = __rest(_options, ["service"]);
    if (service) {
        const operators = options.operators
            ? options.operators
            : (_a = service.options) === null || _a === void 0 ? void 0 : _a.operators;
        const filters = options.filters
            ? options.filters
            : (_b = service.options) === null || _b === void 0 ? void 0 : _b.filters;
        const optionsForFilterQuery = {};
        if (operators) {
            optionsForFilterQuery.operators = operators;
        }
        if (filters) {
            optionsForFilterQuery.filters = filters;
        }
        // @ts-expect-error service has no filterQuery method
        if (service && "filterQuery" in service && typeof service.filterQuery === "function") {
            // @ts-expect-error service has no filterQuery method
            return service.filterQuery({ query }, optionsForFilterQuery);
        }
        else {
            return (0, adapter_commons_1.filterQuery)(query, optionsForFilterQuery);
        }
    }
    return (0, adapter_commons_1.filterQuery)(query, options);
}
exports.filterQuery = filterQuery;
