"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.pushSet = void 0;
const isEqual_js_1 = __importDefault(require("lodash/isEqual.js"));
const get_js_1 = __importDefault(require("lodash/get.js"));
const set_js_1 = __importDefault(require("lodash/set.js"));
const pushSet = (obj, path, val, options) => {
    options = options || {};
    let arr = (0, get_js_1.default)(obj, path);
    if (!arr || !Array.isArray(arr)) {
        arr = [val];
        (0, set_js_1.default)(obj, path, arr);
        return arr;
    }
    else {
        if (options.unique && arr.some(x => (0, isEqual_js_1.default)(x, val))) {
            return arr;
        }
        arr.push(val);
        return arr;
    }
};
exports.pushSet = pushSet;
