"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.validateQueryProperty = void 0;
const commons_1 = require("@feathersjs/commons");
const errors_1 = require("@feathersjs/errors");
const isPlainObject = (value) => commons_1._.isObject(value) && value.constructor === {}.constructor;
const validateQueryProperty = (query, operators = []) => {
    if (!isPlainObject(query)) {
        return query;
    }
    for (const key of Object.keys(query)) {
        if (key.startsWith("$") && !operators.includes(key)) {
            throw new errors_1.BadRequest(`Invalid query parameter ${key}`, query);
        }
        const value = query[key];
        if (isPlainObject(value)) {
            query[key] = (0, exports.validateQueryProperty)(value, operators);
        }
    }
    return Object.assign({}, query);
};
exports.validateQueryProperty = validateQueryProperty;
